#! @PHP_BIN@ -q
<?php

    # PHP Weathermap v0.82 - Pre-release software. For testing
    # Copyright Howard Jones, 2005-2006 howie@thingy.com
    # http://wotsit.thingy.com/haj/cacti/
    # Released under the GNU Public License
    require_once 'Console/Getopt.php';

    require_once "Weathermap.class.php";

    if (!module_checks()) { die ("Quitting: Module checks failed.\n"); }

    $map=new Weathermap;
    $output="html";
    $configfile="weathermap.conf";
    $htmlfile='';
    $imagefile='';
    $DEBUG=0;
    $dumpafter=0;
    $randomdata=0;
    $dumpconfig='';

    // **************************************************************************************
    // THIS IS THE ONE LINE IN HERE YOU MIGHT HAVE TO CHANGE!
    $map->rrdtool="@BIN_RRDTOOL@";
    //$map->rrdtool="/usr/bin/rrdtool";
    // (on Windows, use / instead of \ in pathnames - c:/rrdtool/bin/rrdtool.exe for example)
    // **************************************************************************************

    // initialize object
    $cg=new Console_Getopt();
    $short_opts='';
    $long_opts=array
        (
            "version",
            "help",
            "image-uri=",
            "config=",
            "output=",
            "version",
            "help",
            "debug",
            "randomdata",
            "htmloutput=",
            "dumpafter",
            "bulge",
            "sizedebug",
            "dumpconfig="
        );

    $args=$cg->readPHPArgv();

    $ret=$cg->getopt($args, $short_opts, $long_opts);

    if (PEAR::isError($ret)) { die ("Error in command line: " . $ret->getMessage() . "\n (try --help)\n"); }

    $gopts=$ret[0];

    if (sizeof($gopts) > 0)
    {
        foreach ($gopts as $o)
        {
            switch ($o[0])
            {
                case '--config':
                    $configfile=$o[1];

                    break;

                case '--htmloutput':
                    $htmlfile=$o[1];

                    break;

                case '--dumpafter':
                    $dumpafter=1;

                    break;

                case '--image-uri':
                    $map->imageuri=$o[1];

                    break;

                case '--dumpconfig':
                    $map->dumpconfig=$o[1];

                    break;

                case '--randomdata':
                    $randomdata=1;

                    break;

                case '--debug':
                    $DEBUG=1;

                    $map->debugging=TRUE;
                    $weathermap_debugging=TRUE;
                    break;

                case '--sizedebug':
                    $map->sizedebug=TRUE;

                    break;

                case '--bulge':
                    $map->widthmod=TRUE;

                    break;

                case '--output':
                    $imagefile=$o[1];

                    break;

                case '--version': break;

                case '--help': break;
            }
        }
    }

    if ($DEBUG)
    {
        print "\n------------------------------------\n";
        print "Starting PHP-Weathermap run, with config: $configfile\n";
    }

    if ($map->ReadConfig($configfile))
    {
        # allow command-lines to override the config file, but provide a default if neither are present
        if ($imagefile == '')
        {
            if ($map->imageoutputfile == '') { $imagefile="weathermap.png"; }
            else { $imagefile=$map->imageoutputfile; }
        }

        if ($htmlfile == '')
        {
            if ($map->htmloutputfile != '') { $htmlfile=$map->htmloutputfile; }
        }

        if (!$map->sizedebug)
        {
            if ($randomdata == 1) { $map->RandomData(); }
            else { $map->ReadData(); }
        }

        if ($imagefile != '')
        {
            $map->DrawMap($imagefile);
            $map->imagefile=$imagefile;
        }

        if ($htmlfile != '')
        {
            $fd=fopen($htmlfile, 'w');
            fwrite($fd,
                   '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="refresh" content="300" /><title>' . $map->title
                       . '</title></head><body>');

            if ($map->htmlstyle == "overlib")
            {
                fwrite($fd,
                       "<div id=\"overDiv\" style=\"position:absolute; visibility:hidden; z-index:1000;\"></div>\n");
                fwrite($fd,
                       "<script type=\"text/javascript\" src=\"overlib.js\"><!-- overLIB (c) Erik Bosrup --></script> \n");
            }

            fwrite($fd, $map->MakeHTML());
            fwrite($fd,
                   '<hr />Network Map created with <a href="http://wotsit.thingy.com/haj/cacti/php-weathermap/?vs='
                       . $WEATHERMAP_VERSION . '">PHP Network Weathermap v' . $WEATHERMAP_VERSION
                       . '</a></body></html>');
            fclose ($fd);
        }

        if ($map->dumpconfig != '')
            $map->WriteConfig($map->dumpconfig);

        if ($dumpafter == 1)
            print_r ($map);
    }
    else { die ("Could not read Weathermap config file. No output produced.\n"); }
?>
