-- TABLE

CREATE TABLE `pwm_maps` (
`pwm_id` INT NULL AUTO_INCREMENT PRIMARY KEY ,
`pwm_name` VARCHAR( 255 ) NULL ,
`pwm_alias` VARCHAR( 255 ) NULL ,
`pwm_comment` TEXT NULL,
  KEY `name_index` (`pwm_name`),
  KEY `alias_index` (`pwm_alias`)
) ENGINE = innodb  DEFAULT CHARSET=utf8;

CREATE TABLE `pwm_host_node_relation` (
`phnr_id` INT NULL AUTO_INCREMENT PRIMARY KEY ,
`host_host_id` INT NULL ,
`node_id` VARCHAR( 255 ) NULL,
  KEY `host_index` (`host_host_id`),
  KEY `node_index` (`node_id`)
) ENGINE = innodb  DEFAULT CHARSET=utf8;

CREATE TABLE `pwm_host_link_relation` (
`phlr_id` INT NULL AUTO_INCREMENT PRIMARY KEY ,
`host_host_id` INT NULL ,
`service_service_id` INT NULL ,
`node_start_id` VARCHAR( 255 ) NULL,
`node_end_id` VARCHAR( 255 ) NULL,
  KEY `host_index` (`host_host_id`),
  KEY `service_index` (`service_service_id`),
  KEY `node_start_index` (`node_start_id`),
  KEY `node_end_index` (`node_end_id`)
) ENGINE = innodb  DEFAULT CHARSET=utf8;

ALTER TABLE `pwm_host_node_relation`
  ADD CONSTRAINT `pwm_host_node_relation_ibfk_1` FOREIGN KEY (`host_host_id`) REFERENCES `host` (`host_id`) ON DELETE CASCADE;
  
ALTER TABLE `pwm_host_link_relation`
  ADD CONSTRAINT `pwm_host_link_relation_ibfk_1` FOREIGN KEY (`host_host_id`) REFERENCES `host` (`host_id`) ON DELETE CASCADE,
  ADD CONSTRAINT `pwm_host_link_relation_ibfk_2` FOREIGN KEY (`service_service_id`) REFERENCES `service` (`service_id`) ON DELETE CASCADE,
  ADD CONSTRAINT `pwm_host_link_relation_ibfk_3` FOREIGN KEY (`node_start_id`) REFERENCES `pwm_host_node_relation` (`node_id`) ON DELETE CASCADE;

-- Topology

# Root menu
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPWM', NULL, 4, 404, 25, 1, NULL, NULL, '0', '1', '1', NULL);

# List menu
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_img', NULL, 404, NULL, NULL, 1, NULL, NULL, '0', '1', '1', NULL);
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_img_list', NULL, 404, 40401, 10, 1, './modules/php-weathermap/views/viewMaps.php', NULL, '0', '1', '1', NULL);

# PWM Editor Menu
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPWM_config_initial', NULL, 404, NULL, NULL, 2, NULL, NULL, '0', '1', '1', NULL);
## Configuration
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_conf', NULL, 404, 40411, 10, 2, './modules/php-weathermap/configuration/pwm-editor/phpWeathermap.php', NULL, '0', '1', '1', NULL);
### javascript actions
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPWM_config_initial', NULL, 40411, 4041101, 10, 1, '#', NULL, '0', '0', '0', NULL);
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_add_node', NULL, 40411, 4041102, 20, 1, '#', NULL, '0', '1', '1','add_node');
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_add_link', NULL, 40411, 4041103, 30, 1, '#', NULL, '0', '1', '1','add_link');
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_map_properties', NULL, 40411, 4041104, 40, 1, '#', NULL, '0', '1', '1','map_properties');
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_map_style', NULL, 40411, 4041105, 50, 1, '#', NULL, '0', '1', '1','map_style');
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_position_legend', NULL, 40411, 4041106, 60, 1, '#', NULL, '0', '1', '1','position_legend');
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_position_timestamp', NULL, 40411, 4041107, 70, 1, '#', NULL, '0', '1', '1','position_timestamp');
# Map Generation
INSERT INTO `topology` ( `topology_id` , `topology_name` , `topology_icone` , `topology_parent` , `topology_page` , `topology_order` , `topology_group` , `topology_url` , `topology_url_opt` , `topology_popup` , `topology_modules` , `topology_show`, `topology_OnClick` ) VALUES 
(NULL, 'modPHW_m_img_generate', NULL, 404, 40412, 20, 2, './modules/php-weathermap/configuration/pwm-editor/phpWeathermap.php', '&o=g', '0', '1', '1', NULL);

INSERT INTO `topology_JS` (`id_t_js`, `id_page`, `o`, `PathName_js`, `Init`) VALUES ('', 40411, NULL, './modules/php-weathermap/configuration/pwm-editor/editor.js', 'initJS');

