<?php
/**
Oreon is developped with GPL Licence 2.0 :
http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
Developped by : Julien Mathis - Romain Le Merlus

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon-project.org
*/

	function escape_command($command) {
		return ereg_replace("(\\\$|`)", "", $command);
	}

	require_once 'DB.php';
	require_once ("../../../class/Session.class.php");
	require_once ("../../../class/Oreon.class.php");

	Session::start();
	$oreon =& $_SESSION["oreon"];

	include("../../../oreon.conf.php");
	is_file ("../../../lang/".$oreon->user->get_lang().".php") ? include_once ("../../../lang/".$oreon->user->get_lang().".php") : include_once ("../../../lang/en.php");
	require_once "../../../include/common/common-Func.php";
	
	# Connect to Oreon DB 
	$dsn = array(
	    'phptype'  => 'mysql',
	    'username' => $conf_oreon['user'],
	    'password' => $conf_oreon['password'],
	    'hostspec' => $conf_oreon['host'],
	    'database' => $conf_oreon['db'],
	);

	$options = array(
	    'debug'       => 2,
	    'portability' => DB_PORTABILITY_ALL ^ DB_PORTABILITY_LOWERCASE,
	);

	$pearDB =& DB::connect($dsn, $options);
	if (PEAR::isError($pearDB))
	    die("Unable to connect : " . $pearDB->getMessage());
	
	$dsn = array(
	    'phptype'  => 'mysql',
	    'username' => $conf_oreon['user'],
	    'password' => $conf_oreon['password'],
	    'hostspec' => $conf_oreon['host'],
	    'database' => $conf_oreon['ods'],
	);
	
	$pearDBO =& DB::connect($dsn, $options);
	if (PEAR::isError($pearDBO))
	    die("Unable to connect : " . $pearDBO->getMessage());
	
	$pearDB->setFetchMode(DB_FETCHMODE_ASSOC);
	$pearDBO->setFetchMode(DB_FETCHMODE_ASSOC);
	
	$ok = 1;
		
	if ($ok){
		include_once("../../../DBOdsConnect.php");
		
		$DBRESULT =& $pearDBO->query("SELECT RRDdatabase_path FROM config LIMIT 1");
		if (PEAR::isError($DBRESULT))
			print "Mysql Error : ".$DBRESULT->getDebugInfo();
		$DBRESULT->fetchInto($config);
		$RRDdatabase_path = $config["RRDdatabase_path"];
		$DBRESULT->free();
		unset($config);
		
		$host_id = $_GET["host_id"];
		$svc_id = $_GET["svc_id"];
		
		$start = time() - 24*60*60 - 1;
		$end = time() - 1 ;		

		$DBRESULT->free();	
		$command_line = " graph - --start=".$start. " --end=".$end;

		$template_id = getDefaultGraph($svc_id, 1);

		# get all template infos
		$DBRESULT =& $pearDB->query("SELECT * FROM giv_graphs_template WHERE graph_id = '".$template_id."' LIMIT 1");
		$DBRESULT->fetchInto($GraphTemplate);
		
		$service_description = getMyServiceField($svc_id, "service_description");
		$host_name = getMyHostName($host_id);
		
		$command_line .= " --interlaced -b ".$GraphTemplate["base"]." --imgformat PNG --width=400 --height=100 --title='".$service_description." graph on ".$host_name."' --vertical-label='".$GraphTemplate["vertical_label"]."' ";
		if ($oreon->optGen["rrdtool_version"] == "1.2")
			$command_line .= " --slope-mode ";
		
		if (isset($GraphTemplate["lower_limit"]) && $GraphTemplate["lower_limit"] != NULL)
			$command_line .= "--lower-limit ".$GraphTemplate["lower_limit"]." ";
		if (isset($GraphTemplate["upper_limit"]) && $GraphTemplate["upper_limit"] != NULL)
			$command_line .= "--upper-limit ".$GraphTemplate["upper_limit"]." ";
		if ((isset($GraphTemplate["lower_limit"]) && $GraphTemplate["lower_limit"] != NULL) || (isset($GraphTemplate["upper_limit"]) && $GraphTemplate["upper_limit"] != NULL))
			$command_line .= "--rigid ";

		$DBRESULT_index =& $pearDBO->query("SELECT id FROM index_data WHERE host_name = '".$host_name."' AND service_description = '".$service_description."' LIMIT 1");
		$DBRESULT_index->fetchInto($index);		

		# Init DS template For each curv
		$metrics = array();
		$DBRESULT =& $pearDBO->query("SELECT metric_id, metric_name, unit_name FROM metrics WHERE index_id = '".$index["id"]."' ORDER BY metric_name");
		if (PEAR::isError($DBRESULT))
			print "Mysql Error : ".$DBRESULT->getDebugInfo();
		$cpt = 0;
		$metrics = array();		
		while ($DBRESULT->fetchInto($metric)){
			if (!isset($_GET["metric"]) || (isset($_GET["metric"]) && isset($_GET["metric"][$metric["metric_id"]]))){	
				$metrics[$metric["metric_id"]]["metric_id"] = $metric["metric_id"];
				$metrics[$metric["metric_id"]]["metric"] = str_replace("#S#", "slash_", $metric["metric_name"]);
				$metrics[$metric["metric_id"]]["unit"] = $metric["unit_name"];
				$ds = getDefaultDS($template_id, $cpt, 1);						
				$metrics[$metric["metric_id"]]["ds_id"] = $ds;
				$res_ds =& $pearDB->query("SELECT * FROM giv_components_template WHERE compo_id = '".$ds."'");
				$res_ds->fetchInto($ds_data);
				foreach ($ds_data as $key => $ds_d){
					if ($key == "ds_transparency")
						$metrics[$metric["metric_id"]][$key] = dechex(255-($ds_d*255)/100);
					else
						$metrics[$metric["metric_id"]][$key] = $ds_d;
				}
				$res_ds->free();
				if (preg_match('/DS/', $ds_data["ds_name"], $matches)){
					$metrics[$metric["metric_id"]]["legend"] = str_replace("#S#", "/", $metric["metric_name"]);
				} else {
                	$metrics[$metric["metric_id"]]["legend"] = $ds_data["ds_name"];
				}
				if (strcmp($metric["unit_name"], ""))
					$metrics[$metric["metric_id"]]["legend"] .= " (".$metric["unit_name"].") ";
				$metrics[$metric["metric_id"]]["legend_len"] = strlen($metrics[$metric["metric_id"]]["legend"]);
			}
			$cpt++;
		}
		$DBRESULT->free();
		$cpt = 0;
		$longer = 0;
		foreach ($metrics as $key => $tm){
			if (isset($tm["ds_invert"]) && $tm["ds_invert"])
				$command_line .= " DEF:va".$cpt."=".$RRDdatabase_path.$key.".rrd:".substr($metrics[$key]["metric"],0 , 19).":AVERAGE CDEF:v".$cpt."=va".$cpt.",-1,* ";
			else
				$command_line .= " DEF:v".$cpt."=".$RRDdatabase_path.$key.".rrd:".substr($metrics[$key]["metric"],0 , 19).":AVERAGE ";
			if ($tm["legend_len"] > $longer)
				$longer = $tm["legend_len"];
			$cpt++;
		}

		# Create Legende
		$cpt = 1;
		foreach ($metrics as $key => $tm){
			if ($metrics[$key]["ds_filled"])
				$command_line .= " AREA:v".($cpt-1)."".$tm["ds_color_area"].$tm["ds_transparency"]." ";
			$command_line .= " LINE".$tm["ds_tickness"].":v".($cpt-1);
			$command_line .= $tm["ds_color_line"].":\"";
			$command_line .= $metrics[$key]["legend"];
			for ($i = $metrics[$key]["legend_len"]; $i != $longer + 1; $i++)
				$command_line .= " ";
			$command_line .= "\"";
/*			if ($tm["ds_average"]){
				$command_line .= " GPRINT:v".($cpt-1).":AVERAGE:\"Average\:%8.2lf%s";
				$tm["ds_min"] || $tm["ds_max"] || $tm["ds_last"] ? $command_line .= "\"" : $command_line .= "\\l\" ";
			}
			if ($tm["ds_min"]){
				$command_line .= " GPRINT:v".($cpt-1).":MIN:\"Min\:%8.2lf%s";
				$tm["ds_max"] || $tm["ds_last"] ? $command_line .= "\"" : $command_line .= "\\l\" ";
			}
			if ($tm["ds_max"]){
				$command_line .= " GPRINT:v".($cpt-1).":MAX:\"Max\:%8.2lf%s";
				$tm["ds_last"] ? $command_line .= "\"" : $command_line .= "\\l\" ";
			}
			if ($tm["ds_last"])
				$command_line .= " GPRINT:v".($cpt-1).":LAST:\"Last\:%8.2lf%s\\l\"";
*/			$cpt++;
		}

		$command_line = $oreon->optGen["rrdtool_path_bin"].$command_line." 2>&1";
		$command_line = escape_command("$command_line");
		if ($oreon->optGen["debug_rrdtool"] == "1")
			error_log("[" . date("d/m/Y H:s") ."] RDDTOOL : $command_line \n", 3, $oreon->optGen["debug_path"]."rrdtool.log");
		//print $command_line;
		$fp = popen($command_line  , 'r');
		if (isset($fp) && $fp ) {
			$str ='';
			while (!feof ($fp)) {
		  		$buffer = fgets($fp, 4096);
		 		$str = $str . $buffer ;
			}
			print $str;
		}
	}
?>